<template>
  <Background>
    <CardLayout>
      <template slot="head">
        <CommonHeader :title="products.length ? $t('chefRecommendation') : $t('menu')"
        ></CommonHeader>
      </template>
      <template slot="top">
        <div class="home-top">
          <h1 v-if="products.length == 0 ">{{ $t('fancy')}}</h1>
          <div v-else class="chef-recommended-section">
            <div
              v-for="(product,index) in products"
              class="product"
              :key="index"
              @click="seeProduct(product.id)"
            >
              <Thumbnail class="photo-thumbnail" :src="product.photosURL[0]"></Thumbnail>
              <div class="plaque">
                <div class="info">
                  <span>{{localizedProductName(product)}}</span>
                  <br />
                  <span
                    class="type"
                    :set="category = getCategoryWithId(product.categoryId)"
                  >{{ category? localizedCategoryName(category) : ''}}</span>
                </div>
                <div>
                  <Next></Next>
                </div>
              </div>
            </div>
          </div>
        </div>
      </template>
      <template slot="body">
        <div  class="home-body">
          <div
            v-for="(category,index) in categories"
            class="category"
            :key="index"
            @click="seeCategoryOrSubcategory(category)"
          >
            <CategoryIcon
              size="100px"
              :src="category.iconURL"
              :name="localizedCategoryName(category)"
            ></CategoryIcon>
            <span>{{ localizedCategoryName(category)}}</span>
          </div>
        </div>
        <MiniCart></MiniCart>
      </template>
    </CardLayout>
  </Background>
</template>

<script lang="ts">
import { Component, Vue } from "vue-property-decorator";
import CardLayout from "@/layouts/CardLayout.vue";
import Background from "@/components/Background.vue";
import CategoryIcon from "@/components/CategoryIcon.vue";
import Next from "@/components/Next.vue";
import Thumbnail from "@/components/Thumbnail.vue";
import Category from "@/models/Category";
import Product from "@/models/Product";
import MiniCart from "@/components/MiniCart.vue";
import CommonHeader from "@/components/CommonHeader.vue";
import { localizedProductPrice } from "@/mixins/MenuLocalization";

@Component({
  components: {
    Background,
    CardLayout,
    CommonHeader,
    CategoryIcon,
    Next,
    Thumbnail,
    MiniCart
  }
})
export default class Menu extends Vue {
  categories: Array<Category> = [];
  products: Array<Product> = [];
  showChefRecommended = true;

  seeCategoryOrSubcategory(category: Category) {
    if(category.subcategories.length > 0){
      this.$store.dispatch('setCategoryId', category.id)
      this.$router.push("/subcategories"); 
    }else{
      this.$router.push("/categories/" + category.id);
    }
  }

  seeProduct(productId: string) {
    this.$router.push("/products/" + productId);
  }
  
  getRecommendedProducts() {
    if (this.$store.getters.showRecommended) {
      const products = this.$store.getters.products as Product[];
      return products
        .filter(p => p.chefRecommended && localizedProductPrice(p))
        .sort((c, n) => c.chefRecommendedPriority - n.chefRecommendedPriority);
    }
    return [];
  }

  getCategoryWithId(categoryId: string){
    return this.categories.find( category => category.id == categoryId)
  }

  getCategories() {
    const categories = this.$store.getters.categories as Category[]
    return categories.sort((c,n) => c.order - n.order)
  }

  created() {
    this.categories = this.getCategories()
    this.products = this.getRecommendedProducts()
  }
}
</script>

<style lang="scss" scoped>
.home-head {
  padding: 10px;
  display: flex;
  flex-direction: row;
  color: #ffffff;
  justify-content: space-between;
  align-items: center;

  span {
    margin-left: 20px;
    font-size: 11px;
  }

  button {
    height: 100%;
  }
  
}

.home-top {
  width: 100%;
  color: #ffffff;
  display: flex;
  justify-content: center;
  align-items: center;
  background-size: contain;
  background-position: bottom;
}

.home-body {
  display: flex;
  flex-direction: row;
  flex-wrap: wrap;
  justify-content: flex-start;
  padding: 0.5em 0em;

  .category {
    display: flex;
    flex-direction: column;
    align-items: center;
    color: #646979;
    font-size: 12px;
    padding: 1em 0.5em;
    width: 30%;

    span {
      text-align: center;
      width: 100%;
      word-wrap: break-word;
      margin-top: 0.5em;
    }
  }
}
.chef-recommended-section {
  width: 100%;
  height: 100%;
  display: flex;
  flex-shrink: 0;
  overflow-x: auto;
  padding-top: 20px;

  .product {
    display: flex;
    flex-direction: column;
    flex-shrink: 0;
    margin-left: 2vw;

    .plaque {
      display: flex;
      flex-direction: row;
      width: 170px;
      justify-content: space-between;
      .info {
        span {
          word-wrap: break-word;
        }
        .type {
          font-size: 10px;
          color: #646979;
        }
      }

      .seeProduct {
        width: 20px;
        height: 20px;
      }
    }
    .photo-thumbnail {
      width: 170px;
      height: 120px;
      border-radius: 10px;
    }
  }
}
</style>
